# include "sine.h"
# include "math.h"



#define SIN_TABLE_ANGLE 360
float sin_table[SIN_TABLE_ANGLE];

void generate_sin_table(void) {
    int step = 360 / SIN_TABLE_ANGLE;
    for (int i = 0; i < SIN_TABLE_ANGLE; i++) {
        // 将角度转换为弧度
        float angle = (float)(step * i * PI / 180);
        sin_table[i] = sin(angle);
    }
}

/* angle 是 0-2pi 的浮点数 */
float get_sin(float angle) {
    // 计算查找表索引
    int index = (int)(angle / (2 * PI) * SIN_TABLE_ANGLE) % SIN_TABLE_ANGLE;

    return sin_table[index];
}

float get_cos(float angle) {
    // 计算余弦值的索引，利用正弦表和角度的关系
    int sin_index = (int)((angle+PI/2) / (2 * PI) * SIN_TABLE_ANGLE) % SIN_TABLE_ANGLE;
    return sin_table[sin_index];
}
